unit Inject;

interface

uses
  Windows, SysUtils, Dialogs;

type
  PInjectData = ^TInjectData;
  TInjectData = packed record
    fLoadLibrary: DWORD;
    fFreeLibrary: DWORD;
    sDll: array[0..255] of Char
  end;

  procedure LoadProcedure(data: PInjectData); stdcall;

  procedure InjectDll(pid: DWORD; dll: string; load: Boolean=False);

implementation

procedure LoadProcedure(data: PInjectData);
type
  myLoadLibraryProc = function(lib: PChar): DWORD; stdcall;
var
  hdll: DWORD;
  myLoadLibrary: myLoadLibraryProc;
begin
  myLoadLibrary := myLoadLibraryProc(data.fLoadLibrary);
  hdll := myLoadLibrary(@data.sDll[0]);
end;

procedure InjectDll(pid: DWORD; dll: string; load: Boolean);
var
  hpro, hthread, hlib: HWND;
  data: TInjectData;
  pdata, ifunc: Pointer;
  v: DWORD;
  s: string;
begin
  hpro := OpenProcess(PROCESS_ALL_ACCESS, False, pid);
  if hpro = 0 then
    Exit;
  FillChar(data, SizeOf(data), 0);
  Move(dll[1], data.sDll, Length(dll));
  hlib := GetModuleHandle('Kernel32.dll');
  data.fLoadLibrary := DWORD(GetProcAddress(hlib, 'LoadLibraryA'));
  data.fFreeLibrary := DWORD(GetProcAddress(hlib, 'FreeLibrary'));

  pdata := VirtualAllocEx(hpro, nil, SizeOf(TInjectData), MEM_COMMIT,
    PAGE_EXECUTE_READWRITE);
  if pdata = nil then begin
    CloseHandle(hpro);
    raise Exception.Create('LktmO.');
  end;
  ifunc := VirtualAllocEx(hpro, nil, 48, MEM_COMMIT, PAGE_EXECUTE);
  if ifunc = nil then begin
    VirtualFreeEx(hpro, pdata, SizeOf(data), MEM_DECOMMIT);
    CloseHandle(hpro);
    raise Exception.Create('LktmO.');
  end;
  WriteProcessMemory(hpro, pdata, @data, SizeOf(data), v);
  WriteProcessMemory(hpro, ifunc, @LoadProcedure, 48, v);
//  ShowMessage(Format('%.8X', [Integer(ifunc)]));  
  hthread := CreateRemoteThread(hpro, nil, 0, ifunc, pdata, 0, v);
  WaitForSingleObject(hthread, INFINITE);
  VirtualFreeEx(hpro, pdata, SizeOf(data), MEM_DECOMMIT);
  VirtualFreeEx(hpro, ifunc, 48, MEM_DECOMMIT);  
end;

end.
